#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <omp.h>

#define N 10

int main( void )
{
    int i, data[N];
    int max = INT_MIN; // Initialize to the minimum possible integer

    for (i = 0; i < N; i++)
        data[i] = rand() % 100;

    // Checking
    printf("[%d ", data[0]);
    for (i = 1; i < N; i++)
        printf(", %d", data[i]);
    printf("]\n");

    #pragma omp parallel reduction(max:max) private(i) //we didn't even need mymax!
    {
        int id = omp_get_thread_num();
        int nths = omp_get_num_threads();
        for (i = id; i < N; i += nths)
        {
            if (data[i] > max)
                max = data[i];
        }
    }

    // Checking
    printf("Max: %d\n", max);

    return 0;
}
